import type { DeepPartial } from "./Types";
export declare function isPlainObject<O extends Record<string, any>>(value: O | unknown): value is O;
export declare function mergeReactiveObjects<T extends Record<any, unknown> | Map<unknown, unknown> | Set<unknown>>(target: T, patchToApply: DeepPartial<T>): T;
